/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006-2012, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#include <iostream>

#include <o2scl/lib_settings.h>
#include <o2scl/test_mgr.h>
#include <o2scl/err_hnd.h>

using namespace std;
using namespace o2scl;

int main(void) {
  test_mgr t;
  t.set_output_level(2);
  
  cout << "O2scl version: " << lib_settings.o2scl_version() << endl;
  cout << "Range checking: " << lib_settings.range_check() << endl;
  cout << "EOS library: " << lib_settings.eos_installed() << endl;
  cout << "Particle library: " << lib_settings.part_installed() << endl;
  cout << "HDF support: " << lib_settings.hdf_support() << endl;
  cout << "Data directory: " << lib_settings.get_data_dir() << endl;

  t.report();
  return 0;
}

