/*
  -------------------------------------------------------------------
  
  Copyright (C) 2006-2012, Andrew W. Steiner
  
  This file is part of O2scl.
  
  O2scl is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  
  O2scl is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with O2scl. If not, see <http://www.gnu.org/licenses/>.

  -------------------------------------------------------------------
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <o2scl/constants.h>
#include <o2scl/tov_eos_fast.h>
#include <o2scl/test_mgr.h>
#include <o2scl/nonrel_fermion.h>
#include <o2scl/hdf_file.h>
#include <o2scl/hdf_io.h>
#include <o2scl/hdf_eos_io.h>
#include <o2scl/cold_nstar.h>
#include <o2scl/convert_units_gnu.h>

using namespace std;
using namespace o2scl;
using namespace o2scl_const;
using namespace o2scl_hdf;
using namespace o2scl_fm;

int main(void) {
  test_mgr t;
  t.set_output_level(2);

  if (false) {

    table_units nvbps;
    hdf_file hf;
    hf.open("../../data/o2scl/nvbps.o2");
    hdf_input(hf,nvbps);
    hf.close();

    ovector_base crust_ed=nvbps.get_column("ed");
    ovector_base crust_pr=nvbps.get_column("pr");
    ovector_base crust_nb=nvbps.get_column("nb");

    cold_nstar cns;
    skyrme_eos sk;

    skyrme_load(sk,"SLy4");
    fermion n(mass_neutron,2.0);
    fermion p(mass_proton,2.0);
    cns.set_n_and_p(n,p);

    cns.set_eos(sk);
    cns.calc_eos();

    o2_shared_ptr<table_units>::type core=cns.get_eos_results();

    // Need to fix the units filename resolution
    if (false) {
      convert_units_gnu cng;
      cng.prefix="units -f /home/asteiner/svn/o2scl/misc/units_hck.dat '";
      core->set_convert(cng);
    
      core->convert_to_unit("ed","Msun/km^3");
      core->convert_to_unit("pr","Msun/km^3");
    
      ovector_base core_ed=core->get_column("ed");
      ovector_base core_pr=core->get_column("pr");
      ovector_base core_nb=core->get_column("nb");
    
      tov_eos_fast tef;
    
      tef.check_eos=false;
    
      tef.set_crust_core(nvbps.get_nlines(),crust_ed,crust_pr,crust_nb,
			 core->get_nlines(),core_ed,core_pr,core_nb);
    }

  }

  t.report();
  return 0;
}



